#include <stdio.h>
#include <getopt.h>
#include <err.h>

#include <ihx.h>

using namespace ihx;


static int binary = 0;

static const char optstring[] = "li:";
static struct option longopts[] = {
	{"list", no_argument, NULL, 'l'},
	{"load", required_argument, NULL, 'i'},
	{"binary", no_argument, &binary, 1},
	{"ihx", no_argument, &binary, 0},
	{NULL, 0, NULL, 0}
};

static Buffer buf;

static void do_list() {
	int id = 1;
	for (Buffer::const_iterator i = buf.begin(); i != buf.end(); ++i)
		printf("#%d @0x%X, size=0x%X\n", id++, i->address, i->GetSize());
}

static void help(const char *exe) {
}

int main(int argn, char *argv[]) {
	int cmd, lidx;
	Buffer::Error e;

	while ((cmd = getopt_long(argn, argv, optstring, longopts, &lidx)) != -1) {
		switch (cmd) {
			case 'l':
				do_list();
				break;

			case 'i':
				e = binary ? buf.ReadBIN(optarg) : buf.ReadIHX(optarg);
				if (e) errx(1, Buffer::GetErrorString(e));
				break;

			case 0:
				break;

			default:
				help(*argv);
				return 1;
		}
	}

	return 0;
}
